      subroutine u2dbc_tile(Istr,Iend,Jstr,Jend,grad)
      use Agrif_Types, only : Agrif_tabvars

      use AGRIF_Util

#include "Param_BeforeCall_u2dbc_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2) :: grad

                     
                                    
                                             
      if (AGRIF_Root()) then
        call u2dbc_parent_tile(Istr,Iend,Jstr,Jend,grad)
      else
        call u2dbc_child_tile(Istr,Iend,Jstr,Jend,grad)
      endif
      return
      end
      subroutine u2dbc_parent_tile (Istr,Iend,Jstr,Jend,grad)      


      use Agrif_Util
#include "Param_BeforeCall_u2dbc_parent_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2) :: grad
      

        call Sub_Loop_u2dbc_parent_tile(Istr,Iend,Jstr,Jend,grad, Agrif_
     &tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i
     &(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(103)%array
     &2, Agrif_tabvars(197)%array1, Agrif_tabvars(195)%array1, Agrif_tab
     &vars(79)%array2, Agrif_tabvars(209)%array1, Agrif_tabvars(207)%arr
     &ay1, Agrif_tabvars(74)%array3, Agrif_tabvars_i(150)%iarray0, Agrif
     &_tabvars(104)%array2, Agrif_tabvars_i(148)%iarray0, Agrif_tabvars(
     &75)%array3, Agrif_tabvars(115)%array2, Agrif_tabvars_r(34)%array0,
     & Agrif_tabvars_r(33)%array0, Agrif_tabvars_r(4)%array0, Agrif_tabv
     &ars_l(13)%larray0, Agrif_tabvars_l(14)%larray0, Agrif_tabvars_l(11
     &)%larray0, Agrif_tabvars_l(12)%larray0, Agrif_tabvars_i(8)%iarray0
     &, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars_i(16)%iarray0, Agrif_t
     &abvars_i(15)%iarray0)

      end


#include "Sub_Loop_u2dbc_parent_tile.h"
      subroutine u2dbc_child_tile (Istr,Iend,Jstr,Jend,grad)      


      use Agrif_Util
#include "Param_BeforeCall_u2dbc_child_tile.h"
      integer(4) :: Istr
      integer(4) :: Iend
      integer(4) :: Jstr
      integer(4) :: Jend
      real, dimension(Istr-2:Iend+2,Jstr-2:Jend+2) :: grad
      

        call Sub_Loop_u2dbc_child_tile(Istr,Iend,Jstr,Jend,grad, Agrif_t
     &abvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(
     &13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(171)%array1
     &, Agrif_tabvars(183)%array1, Agrif_tabvars(195)%array1, Agrif_tabv
     &ars(79)%array2, Agrif_tabvars(207)%array1, Agrif_tabvars_i(150)%ia
     &rray0, Agrif_tabvars(74)%array3, Agrif_tabvars_r(34)%array0, Agrif
     &_tabvars_r(33)%array0, Agrif_tabvars_r(4)%array0, Agrif_tabvars(26
     &)%array2, Agrif_tabvars(25)%array2, Agrif_tabvars_l(13)%larray0, A
     &grif_tabvars_l(14)%larray0, Agrif_tabvars_l(11)%larray0, Agrif_tab
     &vars_l(12)%larray0, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)
     &%iarray0, Agrif_tabvars_i(16)%iarray0, Agrif_tabvars_i(15)%iarray0
     &)

      end


#include "Sub_Loop_u2dbc_child_tile.h"
